import {Plugin} from 'ckeditor5/src/core';
import SpanCommand from "./spancommand";
import SpanRemoveCommand from "./spanremovecommand";
//import { Widget, toWidget, toWidgetEditable } from "ckeditor5/src/widget";
import {  getAttrsData } from "./utils";
//import { Enter } from 'ckeditor5/src/enter';
//import { Delete } from 'ckeditor5/src/typing';
//import { first } from 'ckeditor5/src/utils';




const SPAN = 'span';

export default class SpanEditing extends Plugin {
  init() {
    this._defineCommands();
    this._defineSchema();
    this._defineConverters();
  }


  _defineCommands() {
    this.editor.commands.add(
      'addSpan', new SpanCommand(this.editor)
    );
    this.editor.commands.add(
      'removeSpan', new SpanRemoveCommand(this.editor)
    );
  }

  _defineSchema() {
    const schema = this.editor.model.schema;

    schema.register(SPAN, {
      inheritAllFrom: '$text',
      allowChildren: '$text',
      //allowAttributes: [SPAN, 'class', 'title', 'id', 'lang', 'style'], 
      allowAttributes: ['class', 'title', 'id', 'lang', 'style'], 
    });
    /*schema.setAttributeProperties( SPAN, {
			isFormatting: true,
			copyOnEnter: true
		} );*/
  }

  _defineConverters() {
    const schema = this.editor.model.schema;
    const conversion = this.editor.conversion;
    
    conversion.for("downcast").elementToElement({
      model: SPAN,
      view: (modelElement, { writer }) => {
        const attr = getAttrsData(modelElement); 
        const container = writer.createContainerElement("span", attr);
        return container;
      },
    });

    conversion.elementToElement( { model: SPAN, view: 'span' } );

  }


}


