import {Command} from 'ckeditor5/src/core';
import {  getClosestSelectedSpanElement, findLinkElementAncestor  } from "./utils"; 
import { first } from 'ckeditor5/src/utils';


import { DocumentFragment, Element, Position, Range, Schema, Writer } from 'ckeditor5/src/engine';

export default class SpanRemoveCommand extends Command {



  execute(settings) {
    const model = this.editor.model;
    const schema = model.schema;
    const selection = model.document.selection;
    const existingSpan = getClosestSelectedSpanElement(selection);
    
    if(!settings)
      settings = {};


    const selectedElement = selection.getSelectedElement();
    //console.log('selectedElement' , selectedElement) //return the selected text
    //console.log('selection', selection);
    //console.log('selectedElement', selectedElement);
    //console.log('existingSpan', existingSpan);
    //console.log('existingSpan getChild', existingSpan.getChild(0).data);
    //console.log('getRangeText', getRangeText(selection.getFirstRange()));
    //console.log('getFirstRange', selection.getFirstRange());
    //console.log('getLastRange', selection.getLastRange());


    /*const range = selection.getFirstRange();
    const startLink = findLinkElementAncestor( range.start );
    const endLink = findLinkElementAncestor( range.end );
    console.log(startLink, endLink);*/


    //for (const item of range.getItems()) {
    //console.log('item' , item.data) //return the selected text
    //}  

		//const blocks = Array.from( selection.getSelectedBlocks() );
      
    model.change((writer) => {

      if(existingSpan)
      { 
        const startOffset = existingSpan.startOffset;
        const data = existingSpan.getChild(0).data;

        writer.remove(existingSpan);
        const currentAttributes = selection.getAttributes();
        const insertPosition = selection.focus;
    
        writer.insertText( data, currentAttributes, insertPosition );
      }
    });
  }

}

