// A helper function that retrieves and concatenates all text within the model range.
export function getRangeText(range) {
  return Array.from(range.getItems()).reduce((rangeText, node) => {
    if (!(node.is('text') || node.is('textProxy'))) {
      return rangeText;
    }

    return rangeText + node.data;
  }, '');
}


export function isSpan(node) {
  return !!node && node.is("element", 'span');
  return node.is('attributeElement') && !!node.getCustomProperty('span');
}

export function findLinkElementAncestor(position) {
  return position.getAncestors().find(function (ancestor) {
      return isSpan(ancestor);
  }) || null;
}



export function getClosestSelectedSpanElement(selection) {
  const selectedElement = selection.getSelectedElement();
  return isSpan(selectedElement)
    ? selectedElement
    : selection.getFirstPosition().findAncestor("span");
}




export function getAttrsData(modelItem) {
  let currentAttributes = {}; 
  modelItem._attrs.forEach((value, key) => { 
    if (value) {
      currentAttributes[key] = value;
    }
  });
  return currentAttributes;
}

export function getRangesOfBlockGroups( writer, blocks) {
  let startPosition;
  let i = 0;
  const ranges = [];

  while ( i < blocks.length ) {
    const block = blocks[ i ];
    const nextBlock = blocks[ i + 1 ];

    if ( !startPosition ) {
      startPosition = writer.createPositionBefore( block );
    }

    if ( !nextBlock || block.nextSibling != nextBlock ) {
      ranges.push( writer.createRange( startPosition, writer.createPositionAfter( block ) ) );
      startPosition = null;
    }

    i++;
  }

  return ranges;
}

export function findQuote( elementOrPosition) {

	return (elementOrPosition.parent && elementOrPosition.parent.name == 'span') ? elementOrPosition.parent : null;
}


export function checkCanBeQuoted( schema, block ) {
  // TMP will be replaced with schema.checkWrap().
  const isBQAllowed = schema.checkChild( block.parent, 'span' );
  const isBlockAllowedInBQ = schema.checkChild( [ '$root', 'span' ], block );

  return isBQAllowed && isBlockAllowedInBQ;
}